using UnityEngine;
using System.Collections;

public class CoroutinesScript : MonoBehaviour {

	private int i = 3;

	void Start () {
		StartCoroutine(ExampleCoroutine());
		//StartCoroutine(InfiniteLoop());
	}

	void Update() {
		print(i);
		if (Input.GetButtonDown("Jump")) {
			StopAllCoroutines();
			StartCoroutine(LerpCoroutine());
		}
	}
	
	IEnumerator ExampleCoroutine() {
		i = 5;
		//yield return null;
		i = 10;
		yield return null;
		yield return new WaitForSeconds(3);
		print("3 seconds have passed");
	}

	IEnumerator InfiniteLoop() {
		while (true) {
			print("SPAM");
			yield return null;
		}
	}

	IEnumerator LerpCoroutine() {
		float tParam = 0;
		while (tParam < 1) {
			tParam += Time.deltaTime;
			transform.localScale = new Vector3(1, Mathf.Lerp(1, 0.1f, tParam), 1);
			yield return null;
		}
	}

}
